(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.queue = mod.exports;
  }
})(this, function (exports) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var Queue = function () {
    function Queue() {
      _classCallCheck(this, Queue);

      this.data = [];
      this.index = 0;
    }

    _createClass(Queue, [{
      key: "queue",
      value: function queue(value) {
        this.data.push(value);
      }
    }, {
      key: "dequeue",
      value: function dequeue() {
        if (this.index > -1 && this.index < this.data.length) {
          var result = this.data[this.index++];

          if (this.isEmpty()) {
            this.reset();
          }

          return result;
        }
      }
    }, {
      key: "dequeueAll",
      value: function dequeueAll(cb) {
        if (!_.isFunction(cb)) {
          throw new Error("Please provide a callback");
        }

        while (!this.isEmpty) {
          var _dequeue = this.dequeue(),
              method = _dequeue.method,
              args = _dequeue.args;

          cb(method, args);
        }

        this.reset();
      }
    }, {
      key: "reset",
      value: function reset() {
        this.data.length = 0;
        this.index = 0;
      }
    }, {
      key: "isEmpty",
      get: function get() {
        return this.index >= this.data.length;
      }
    }]);

    return Queue;
  }();

  exports.default = Queue;
});